﻿using System;
using System.Windows.Forms;

namespace ListViewExampleWinForms
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void addItemsButton_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            for (var i = 0; i < 500; i++)
            {
                var item = new ListViewItem(new[] {"Item #" + i, GetColour(i)}, i%imageList1.Images.Count);
                listView1.Items.Add(item);
            }
            listView1.Update();
        }

        private string GetColour(int itemNr)
        {
            var colour = string.Empty;

            var mod = itemNr - itemNr/7*7 + 1;

            switch (mod)
            {
                case 1:
                    colour = "Red";
                    break;
                case 2:
                    colour = "Orange";
                    break;
                case 3:
                    colour = "Yellow";
                    break;
                case 4:
                    colour = "Green";
                    break;
                case 5:
                    colour = "Blue";
                    break;
                case 6:
                    colour = "Indigo";
                    break;
                case 7:
                    colour = "Violet";
                    break;
            }
            return colour;
        }

        private void showLargeIcon_Click(object sender, EventArgs e)
        {
            if (IsListViewPopulated())
                listView1.View = View.LargeIcon;
        }

        private void showSmallIcon_Click(object sender, EventArgs e)
        {
            if (IsListViewPopulated())
                listView1.View = View.SmallIcon;
        }

        private void showDetails_Click(object sender, EventArgs e)
        {
            if (IsListViewPopulated())
                listView1.View = View.Details;
        }

        private void showList_Click(object sender, EventArgs e)
        {
            if (IsListViewPopulated())
                listView1.View = View.List;
        }

        private bool IsListViewPopulated()
        {
            var result = true;

            if (listView1.Items.Count == 0)
            {
                MessageBox.Show("Please add items to the ListView.",
                    "Warning",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Warning);
                result = false;
            }

            return result;
        }
    }
}